/*
 * @author lsy
 * @date   2020/6/28
 **/
import 'package:flutter_common/Annotations/anno/Get.dart';
import 'package:flutter_common/Annotations/anno/Post.dart';
import 'package:flutter_common/Annotations/anno/Query.dart';
import 'package:flutter_common/Annotations/anno/ServiceCenter.dart';
import 'package:gm_flutter/ClueModel/server/entity/ConsultHospitalsBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/ConsultQuestionsBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/LevelOneFeedList.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanBarBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanCompareDetail.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanConsultBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlansCompareFeed.dart';
import 'package:gm_flutter/ClueModel/server/entity/ProjectDetailsItem.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanFeedBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/DiscussLowPriceModelBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/DiscussLowPriceAuthBean.dart';

@ServiceCenter()
abstract class ClueApi {
  @Get("/api/janus/plans/plan_detail")
  ProjectDetailsItem getProjectDetails(@Query("plan_id") int plan_id);

  @Get("/api/janus/plans/compare_feed")
  PlansCompareFeed getPlansCompareFeed(
      @Query("plan_id") int plan_id, @Query("plan_type") int plan_type);

  @Get("api/janus/plans/plan_feed")
  LevelOneFeedList getLevelOneList(@Query("plan_id") int plan_id,
      @Query("tab_type") String tab_type, @Query("page") int page);

  @Get("api/janus/plans/consult_hospitals")
  ConsultHospitalsBean getLevelMechanismList(
      @Query("plan_id") int plan_id, @Query("page") int page);

  @Get("api/janus/plans/plan_compare")
  PlanCompareDetail getPlanCompareDetail(@Query("plan_ids") String planIds);

  @Get("api/janus/plans/options")
  PlanBean getPlan();

  @Get("api/janus/plans/feed")
  PlanFeedBean getPlanFeed(
    @Query("tag_id") String tag_id,
    @Query("order_by") String order_by,
    @Query("current_city_id") String current_city_id,
    @Query("min_price") String min_price,
    @Query("max_price") String max_price,
    @Query("rank_type") String rank_type,
    @Query("page") int page,
  );

  @Get("/api/janus/plans/consult_questions")
  ConsultQuestionsBean getConsultQuestions(@Query("plan_id") int plan_id);

  @Post("api/janus/plans/plan_consult")
  PlanConsultBean sendMessage(
      @Query("doctor_ids") String doctor_ids,
      @Query("hospital_ids") String hospital_ids,
      @Query("question") String question,
      @Query("plan_id") int plan_id);

  @Get("api/janus/plans/rank")
  PlanBarBean getPlanBar(@Query("rank_type") String rank_type);

  @Post("api/janus/plans/plan_phone_authorize")
  DiscussLowPriceModelBean getPopviewData(
    @Query("plan_id") String planId,
    @Query("hospital_id") String hospitalId,
    @Query("doctor_id") String doctorId,
  );

  @Post("api/janus/plans/agree_phone_authorize")
  DiscussLowPriceAuthBean givePhoneAuth(
      @Query("lead_phone_request_id") int leadPhoneRequestId);

//  @Get("api/janus/plans/plan_overview")
//  PlanOverViewBean getPlanOverView(@Query("plan_id") int plan_id);
}
