// GENERATED CODE - DO NOT MODIFY BY HAND

// **************************************************************************
// ServiceGenerator
// **************************************************************************

import 'dart:convert';

import 'dart:io';

import 'package:rxdart/rxdart.dart';

import 'package:dio/dio.dart';

import 'package:flutter/foundation.dart';

import 'package:gm_flutter/ClueModel/server/entity/ProjectDetailsItem.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlansCompareFeed.dart';
import 'package:gm_flutter/ClueModel/server/entity/LevelOneFeedList.dart';
import 'package:gm_flutter/ClueModel/server/entity/ConsultHospitalsBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanCompareDetail.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanFeedBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/ConsultQuestionsBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanConsultBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanBarBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/DiscussLowPriceModelBean.dart';
import 'package:gm_flutter/ClueModel/server/entity/DiscussLowPriceAuthBean.dart';

const bool inProduction = const bool.fromEnvironment("dart.vm.product");

class ClueApiImpl {
  static JsonEncoder encoder = JsonEncoder.withIndent('  ');

  static ClueApiImpl _instance;

  ClueApiImpl._() {}

  static ClueApiImpl getInstance() {
    if (_instance == null) {
      _instance = ClueApiImpl._();
    }
    return _instance;
  }

  Stream<ProjectDetailsItem> getProjectDetails(Dio _dio, int plan_id) {
    return Stream.fromFuture(get(_dio, '/api/janus/plans/plan_detail', data: {
      'plan_id': plan_id,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(
            compute(parseProjectDetailsItem, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<PlansCompareFeed> getPlansCompareFeed(
      Dio _dio, int plan_id, int plan_type) {
    return Stream.fromFuture(get(_dio, '/api/janus/plans/compare_feed', data: {
      'plan_id': plan_id,
      'plan_type': plan_type,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(
            compute(parsePlansCompareFeed, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<LevelOneFeedList> getLevelOneList(
      Dio _dio, int plan_id, String tab_type, int page) {
    return Stream.fromFuture(get(_dio, 'api/janus/plans/plan_feed', data: {
      'plan_id': plan_id,
      'tab_type': tab_type,
      'page': page,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(
            compute(parseLevelOneFeedList, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<ConsultHospitalsBean> getLevelMechanismList(
      Dio _dio, int plan_id, int page) {
    return Stream.fromFuture(
        get(_dio, 'api/janus/plans/consult_hospitals', data: {
      'plan_id': plan_id,
      'page': page,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(
            compute(parseConsultHospitalsBean, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<PlanCompareDetail> getPlanCompareDetail(Dio _dio, String planIds) {
    return Stream.fromFuture(get(_dio, 'api/janus/plans/plan_compare', data: {
      'plan_ids': planIds,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(
            compute(parsePlanCompareDetail, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<PlanBean> getPlan(
    Dio _dio,
  ) {
    return Stream.fromFuture(get(_dio, 'api/janus/plans/options'))
        .flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(compute(parsePlanBean, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<PlanFeedBean> getPlanFeed(
      Dio _dio,
      String tag_id,
      String order_by,
      String current_city_id,
      String min_price,
      String max_price,
      String rank_type,
      int page) {
    return Stream.fromFuture(get(_dio, 'api/janus/plans/feed', data: {
      'tag_id': tag_id,
      'order_by': order_by,
      'current_city_id': current_city_id,
      'min_price': min_price,
      'max_price': max_price,
      'rank_type': rank_type,
      'page': page,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(compute(parsePlanFeedBean, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<ConsultQuestionsBean> getConsultQuestions(Dio _dio, int plan_id) {
    return Stream.fromFuture(
        get(_dio, '/api/janus/plans/consult_questions', data: {
      'plan_id': plan_id,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(
            compute(parseConsultQuestionsBean, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<PlanConsultBean> sendMessage(Dio _dio, String doctor_ids,
      String hospital_ids, String question, int plan_id) {
    return Stream.fromFuture(post(_dio, 'api/janus/plans/plan_consult', data: {
      'doctor_ids': doctor_ids,
      'hospital_ids': hospital_ids,
      'question': question,
      'plan_id': plan_id,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(
            compute(parsePlanConsultBean, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<PlanBarBean> getPlanBar(Dio _dio, String rank_type) {
    return Stream.fromFuture(get(_dio, 'api/janus/plans/rank', data: {
      'rank_type': rank_type,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(compute(parsePlanBarBean, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<DiscussLowPriceModelBean> getPopviewData(
      Dio _dio, String planId, String hospitalId, String doctorId) {
    return Stream.fromFuture(
        post(_dio, 'api/janus/plans/plan_phone_authorize', data: {
      'plan_id': planId,
      'hospital_id': hospitalId,
      'doctor_id': doctorId,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(
            compute(parseDiscussLowPriceModelBean, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  Stream<DiscussLowPriceAuthBean> givePhoneAuth(
      Dio _dio, int leadPhoneRequestId) {
    return Stream.fromFuture(
        post(_dio, 'api/janus/plans/agree_phone_authorize', data: {
      'lead_phone_request_id': leadPhoneRequestId,
    })).flatMap((value) {
      if (value != null &&
          (value.statusCode >= 200 && value.statusCode < 300)) {
        return Stream.fromFuture(
            compute(parseDiscussLowPriceAuthBean, value.toString()));
      } else {
        throw Exception("--未知网络错误--");
      }
    });
  }

  ///==================base method==================

  Future<Response> get(Dio _dio, url, {data, options, cancelToken}) async {
    Response response;
    try {
      response = await _dio.get(url,
          queryParameters: data, options: options, cancelToken: cancelToken);
      _printHttpLog(response);
    } on DioError catch (e) {
      print('get error---------$e  ${formatError(e)}');
      throw e;
    }
    return response;
  }

  Future<Response> post(Dio _dio, url, {data, options, cancelToken}) async {
    Response response;
    try {
      response = await _dio.post(url,
          data: FormData.fromMap(data),
          options: options,
          cancelToken: cancelToken);
      _printHttpLog(response);
    } on DioError catch (e) {
      print('get error---------$e  ${formatError(e)}');
      throw e;
    }
    return response;
  }

  Future<Response> put(Dio _dio, url, {data, options, cancelToken}) async {
    Response response;
    try {
      response = await _dio.put(url,
          data: FormData.fromMap(data),
          options: options,
          cancelToken: cancelToken);
      _printHttpLog(response);
    } on DioError catch (e) {
      print('get error---------$e  ${formatError(e)}');
      throw e;
    }
    return response;
  }

  Future<Response> delete(Dio _dio, url, {data, options, cancelToken}) async {
    Response response;
    try {
      response = await _dio.delete(url,
          data: FormData.fromMap(data),
          options: options,
          cancelToken: cancelToken);
      _printHttpLog(response);
    } on DioError catch (e) {
      print('get error---------$e  ${formatError(e)}');
      throw e;
    }
    return response;
  }

  Future<Response> upload(Dio _dio, url, String key, String path,
      {Map<String, dynamic> data, options, cancelToken}) async {
    Response response;
    print("UPLOAD===> URL:$url  {$key : $path }   data:$data");
    MultipartFile file = await MultipartFile.fromFile(path,
        filename: path.substring(path.lastIndexOf("/") + 1, path.length));
    if (data == null) {
      data = new Map<String, dynamic>();
    }
    data.putIfAbsent(key, () => file);
    try {
      response = await _dio.post(url,
          data: FormData.fromMap(data),
          options: options,
          cancelToken: cancelToken);
      _printHttpLog(response);
    } on DioError catch (e) {
      print('get error---------$e  ${formatError(e)}');
      throw e;
    }
    return response;
  }

  void _printHttpLog(Response response) {
//    if (!inProduction) {
//      try {
//        printRespond(response);
//      } catch (ex) {
//        print("Http Log" + " error......");
//      }
//    }
  }

  static void printRespond(Response response) {
    Map httpLogMap = Map();
    httpLogMap.putIfAbsent("requestMethod", () => "${response.request.method}");
    httpLogMap.putIfAbsent("requestUrl", () => "${response.request.uri}");
    httpLogMap.putIfAbsent("requestHeaders", () => response.request.headers);
    httpLogMap.putIfAbsent(
        "requestQueryParameters", () => response.request.queryParameters);
    if (response.request.data is FormData) {
      httpLogMap.putIfAbsent("requestDataFields",
          () => ((response.request.data as FormData).fields.toString()));
    }
    httpLogMap.putIfAbsent(
        "respondData", () => json.decode(response.toString()));
    printJson(httpLogMap);
  }

  static void printJson(Object object) {
    try {
      var encoderString = encoder.convert(object);
      debugPrint(encoderString);
    } catch (e) {
      print(e);
    }
  }

  String formatError(DioError e) {
    String reason = "";
    if (e.type == DioErrorType.CONNECT_TIMEOUT) {
      reason = "连接超时 ${e.message}";
    } else if (e.type == DioErrorType.SEND_TIMEOUT) {
      reason = "请求超时 ${e.message}";
    } else if (e.type == DioErrorType.RECEIVE_TIMEOUT) {
      reason = "响应超时 ${e.message}";
    } else if (e.type == DioErrorType.RESPONSE) {
      reason = "出现异常 ${e.message}";
    } else if (e.type == DioErrorType.CANCEL) {
      reason = "请求取消 ${e.message}";
    } else {
      reason = "未知错误 ${e.message}";
    }
    return reason;
  }
}

ProjectDetailsItem parseProjectDetailsItem(String value) {
  return ProjectDetailsItem.fromJson(json.decode(value));
}

PlansCompareFeed parsePlansCompareFeed(String value) {
  return PlansCompareFeed.fromJson(json.decode(value));
}

LevelOneFeedList parseLevelOneFeedList(String value) {
  return LevelOneFeedList.fromJson(json.decode(value));
}

ConsultHospitalsBean parseConsultHospitalsBean(String value) {
  return ConsultHospitalsBean.fromJson(json.decode(value));
}

PlanCompareDetail parsePlanCompareDetail(String value) {
  return PlanCompareDetail.fromJson(json.decode(value));
}

PlanBean parsePlanBean(String value) {
  return PlanBean.fromJson(json.decode(value));
}

PlanFeedBean parsePlanFeedBean(String value) {
  return PlanFeedBean.fromJson(json.decode(value));
}

ConsultQuestionsBean parseConsultQuestionsBean(String value) {
  return ConsultQuestionsBean.fromJson(json.decode(value));
}

PlanConsultBean parsePlanConsultBean(String value) {
  return PlanConsultBean.fromJson(json.decode(value));
}

PlanBarBean parsePlanBarBean(String value) {
  return PlanBarBean.fromJson(json.decode(value));
}

DiscussLowPriceModelBean parseDiscussLowPriceModelBean(String value) {
  return DiscussLowPriceModelBean.fromJson(json.decode(value));
}

DiscussLowPriceAuthBean parseDiscussLowPriceAuthBean(String value) {
  return DiscussLowPriceAuthBean.fromJson(json.decode(value));
}
